import sys
import os
import subprocess
import time
import platform
import shutil

def main():
    
    system = sys.platform
    local = os.getcwd()

    def progress(count, total, status=''):
        bar_len = 60
        filled_len = int(round(bar_len * count / float(total)))

        percents = round(100.0 * count / float(total), 1)
        bar = '=' * filled_len + '-' * (bar_len - filled_len)
        sys.stdout.write('[%s] %s%s ...%s\r' % (bar, percents, '%', status))
        sys.stdout.flush()

    try:
        if len(sys.argv) == 1:
            print('\n[Dash APP]: You must specify an argument [create] + <projectname>.')
            sys.exit(0)
        elif len(sys.argv) == 2:
            if sys.argv[1] == 'create':
                print('\n[Dash APP]: You must specify project name.')
                sys.exit(0)
            else:
                print('\n[Dash APP]: You must use [create]\n')
                sys.exit(0)
        elif len(sys.argv) == 3:
            try:
                total = 15
                i = 0
                if sys.argv[1] == 'create':
                    name = sys.argv[2]
                    git = f'git clone https://github.com/cenguidanos/dash-cli.git {name} -q'
                    try:
                        if system == "win32":
                            os.chdir(local)
                            os.system(git)
                            sys.stdout.write('\n')
                            print('[Dash APP]: Now, the installation needs to remove the .git remote folder.')
                            subprocess.Popen(f"rmdir /s .\{name}\.git", shell=True).communicate()
                            while i < total:
                                progress(i, total, status='Creating files...')
                                time.sleep(0.1)                        
                                i += 1
                        else:
                            os.chdir(local)
                            os.system(git)
                            sys.stdout.write('\n')
                            shutil.rmtree(f'./{name}/.git')
                            while i < total:
                                progress(i, total, status='Creating files...')
                                time.sleep(0.1)                        
                                i += 1                     
                    except:
                        print('''\n[Dash APP]: Problems with the repository or
                        Problems with user permissions, sorry.''')
                        sys.exit(0)                                                            
                else:
                    print('\n[Dash APP]: Use [create] for install project.')
                    sys.exit(0)
            except:
                print('\n[Dash APP]: Problems creating files, sorry.\n')
                sys.exit(0)

            if system == "win32":
                subprocess.Popen("cls", shell=True).communicate()
                print('''
                \n[Dash APP]: Your new project is created. ¡Enjoy!\n''')
                
            else:
                print("\033c", end="")
                print('''
                \n[Dash APP]: Your new project is created. ¡Enjoy!\n''')
                

        elif len(sys.argv) >= 4:                
            print('\n[Dash APP]: Actually, dash-cli only accepts two arguments [create] + [projectname].')
            sys.exit(0)
        
    except:
        print('[Dash APP]: Finishing program.\n')
        sys.exit(0)

if __name__ == '__main__':
    main()
